<template>
    <modal name="card-exp-modal"
           class="arcticmodal-container full-viewport"
           width="600"
           height="auto"
           :adaptive=true
           @before-open="$helpers.noscroll(true)"
           @before-close="$helpers.noscroll(false);">

        <div class="container m-header ">
            <div class="box-modal_close arcticmodal-close" @click="$modal.hide('card-exp-modal');"></div>
            <div class="row">
                <div class="column">
                    <h3>Срок действия карты</h3>
                </div>
            </div>
        </div>
        <div class="container  my-accounts-modal1  feedback-block">

            <div class="row">
                <div class="columns twelve">
                    <div class="card-period">
                        <p>Для взятия займа на выбранную карту <b>({{account.description}})</b> необходимо указать срок ее действия</p>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="columns six adaptive-col first-col">
                    <label for="valid_month">Месяц</label>
                    <select
                            :class="{error: hasError.month}"
                            v-validate="'required'"
                            ref="month"
                            id="valid_month"
                            placeholder=""
                            name="valid_month"
                            v-model.number="month">
                        <option :value="v" v-for="v in months" :key="v">{{v}}</option>
                    </select>
                </div>
                <div class="columns six adaptive-col">
                    <label for="valid_year">Год</label>
                    <select
                            :class="{error: hasError.year}"
                            v-validate="'required'"
                            ref="year"
                            id="valid_year"
                            name="valid_year"
                            v-model.number="year">
                        <option :value="v" v-for="v in range(new Date().getFullYear() - 2000, new Date().getFullYear() - 2000 + 15)" :key="v">{{v}}</option>
                    </select>
                </div>
            </div>
            <div class="row">
                <div class="columns twelwe">
                    <div class="center">
                        <button @click="save" :disabled="loading">Сохранить</button>
                    </div>
                </div>
            </div>
        </div>
    </modal>
</template>

<script>
    import Loader from '@/components/Loader'

    export default {
        name: 'card-exp-modal',
        components: {
            Loader
        },
        props: {
            account: {
                required: true,
                type: Object,
            }
        },
        data () {
            return {
                month: 0,
                year: 0,
                loading: false,
                hasError: {
                    month: false,
                    year: false,
                },
            }
        },
        computed: {
            months () {
                if (this.year && this.year.toString() === this.$dayjs().format('YY')) {
                    return this.range(this.$dayjs().format('M'), 12)
                }
                return this.range(1, 12)
            }
        },
        watch: {
            month () {
                this.$set(this.hasError, 'month', false);
            },
            year () {
                this.$set(this.hasError, 'year', false);
            }
        },
        mounted () {
            this.$validator.attach({ name: 'valid_year', rules: 'required' })
            this.$validator.attach({ name: 'valid_month', rules: 'required' })
        },
        methods: {
            range (from, to) {
                let arrayOfString = []
                for (let i = from; i <= to; i++) {
                    arrayOfString.push(String(i))
                }
                return arrayOfString
            },
            save () {

                if (this.year && this.year.toString() === this.$dayjs().format('YY')) {
                    if (this.month < parseInt(this.$dayjs().format('MM'))) {
                        this.$toastr.error('Срок действия карты истек', 'Ошибка');
                        this.$set(this.hasError, 'year', true);
                        this.$set(this.hasError, 'month', true);
                        return false;
                    }
                }

                if (this.year && this.month) {
                    this.loading = true;
                    this.hasError = {
                        month: false,
                        year: false,
                    };

                    this.$backend.api.accounts.update({
                        id: this.account.id,
                        year: this.year,
                        month: this.month
                    }).then(() => {
                        this.$emit('set', true);
                    }).catch((e) => {
                        this.$errors(e?.errors, {

                        });
                    }).finally(() => {
                        this.loading = false;
                    })
                } else {
                    this.$toastr.error('Укажите срок действия', 'Ошибка');
                    this.$set(this.hasError, 'year', !this.year);
                    this.$set(this.hasError, 'month', !this.month);

                }

            }
        }
    };
</script>

<style scoped>

</style>
